#ifndef _CHardAttachCamera_H_
#define _CHardAttachCamera_H_

#include "CBasicCamera.h"
#include "Constants.h"

#include <queue>
using std::queue;

#include <string>
using std::string;

#include <vector>
using std::vector;

#define QUEUE_BUFFER_SIZE 3
#define OFFSET_X 0.0f
#define OFFSET_Y 1.5f
#define OFFSET_Z -5.0f

class CHardAttachCamera : public CBasicCamera
{
protected:

	D3DXVECTOR3 m_CurrentOffset;
	D3DXVECTOR3 m_CurrentLookAt;

	D3DXVECTOR3 m_StartOffset;
	D3DXVECTOR3 m_StartLookAt;

	D3DXVECTOR3 m_EndOffset;
	D3DXVECTOR3 m_EndLookAt;

	D3DXVECTOR3 m_CurrentPosition;
	D3DXVECTOR3 m_EndPosition;

	D3DXVECTOR3 m_SavedOffset;
	D3DXVECTOR3 m_SavedLookAt;

	/*vector<D3DXVECTOR3> m_vOffsets;
	vector<D3DXVECTOR3> m_vLookAts;*/

	int			m_nCurrentWaypoint;
	int			m_nEndWaypoint;

	float		m_fCurrentMu;
	float		m_fCurrentPositionMu;

	float		m_fCurrentMuX;
	float		m_fCurrentMuY;
	float		m_fCurrentMuZ;

	bool		m_bTransitioning;
	bool		m_bBoosting;
	bool		m_bTransitionWhenDone;

private:

	CHardAttachCamera(const CHardAttachCamera&);
	CHardAttachCamera &operator = (const CHardAttachCamera&);

public:
	CHardAttachCamera();
	CHardAttachCamera(const string& cameraName);
	CHardAttachCamera(const string& cameraName, const D3DXVECTOR3& startPosition);
	CHardAttachCamera(const string& cameraName, const D3DXVECTOR3& startPosition, const D3DXVECTOR3& startLookAt);
	CHardAttachCamera(const string& cameraName, const D3DXVECTOR3& startPosition, CGameObject* startTarget);
	~CHardAttachCamera();

	void Update(void);

	D3DXVECTOR3 GetOffset() {return m_CurrentOffset;}
	void SetOffset(D3DXVECTOR3 offset) {m_CurrentOffset = offset;}

	void Init();
	
	void SetActive(bool value);
	void SwitchCameraPosition(D3DXVECTOR3 offset, D3DXVECTOR3 lookAt);

	float LinearInterpolate(float val1,float val2, float mu);
};

#endif