#include "CVertexShader.h"
#include "CDirect3D.h"

CVertexShader::CVertexShader()
{
	m_VertexShader = 0;
	m_pShader = 0;
	m_pErrorBuffer = 0;
	m_pConstantTable = 0;
}

CVertexShader::~CVertexShader()
{

}

CShader& CVertexShader::Create(string shaderName, string shaderFileName, string shaderEntryPoint, string shaderVersion)
{
	HRESULT hr;

	ID3DXConstantTable* constantTable = 0;
	ID3DXBuffer* shader = 0;
	ID3DXBuffer* errorBuffer = 0;

	m_szName = shaderName;
	m_szFileName = shaderFileName;
	m_szEntryPoint = shaderEntryPoint;
	m_szVersion = shaderVersion;

	hr = D3DXCompileShaderFromFile(
			m_szFileName.c_str(),
			0,
			0,
			m_szEntryPoint.c_str(),
			m_szVersion.c_str(),
			D3DXSHADER_DEBUG | D3DXSHADER_ENABLE_BACKWARDS_COMPATIBILITY,
			&m_pShader,
			&m_pErrorBuffer,
			&m_pConstantTable);

	if (m_pErrorBuffer)
	{
		::MessageBox(0, (char*)m_pErrorBuffer->GetBufferPointer(), 0, 0);
		errorBuffer->Release();
	}

	if (FAILED(hr))
	{
		return CVertexShader();
	}

	m_pDevice = Direct3D().GetDirect3DDevice();

	m_pDevice->CreateVertexShader((DWORD*)m_pShader->GetBufferPointer(), &m_VertexShader);

	return *this;
}

bool CVertexShader::Release()
{
	m_VertexShader->Release();

	//m_pConstantTable->SetMatrix()

	return true;
}

bool CVertexShader::SetShader()
{
	m_pDevice->SetVertexShader(m_VertexShader);

	return true;
}
